<template>
  <div class="home">
    <HelloWorld msg="Welcome to YouTrack App"/>
    <div class="board">
      <div 
        class="board-column"
        @drop="onDrop($event, 1)"  
        @dragover.prevent  
        @dragenter.prevent
      >
        <div class="board-column__header">
          Backlog
        </div>
        <div
          v-for="item in listBacklog"  
          :key="item.id"
          class="board-column__list"
          draggable="true"  
          @dragstart="startDrag($event, item)"
        >
          {{ item.name }}
        </div>
      </div>

      <div 
        class="board-column"
        @drop="onDrop($event, 2)"  
        @dragover.prevent  
        @dragenter.prevent
      >
        <div class="board-column__header">
          In Progress
        </div>
        <div
          v-for="item in listProgress"  
          :key="item.id"
          class="board-column__list"
          draggable="true"
          @dragstart="startDrag($event, item)"
        >
          {{ item.name }}
        </div>
      </div>

      <div 
        class="board-column"
        @drop="onDrop($event, 3)"  
        @dragover.prevent  
        @dragenter.prevent
      >
        <div class="board-column__header">
          Done
        </div>
        <div
          v-for="item in listDone"  
          :key="item.id"
          class="board-column__list"
          draggable="true"  
          @dragstart="startDrag($event, item)"
        >
          {{ item.name }}
        </div>
      </div>
    </div>
  </div>
</template>

<script>
// @ is an alias to /src
import HelloWorld from '@/components/HelloWorld.vue'

export default {
  name: 'Home',
  components: {
    HelloWorld,
  },
  data() {
    return {
      listTask: [
        {
          id: 1,
          name: 'Task 1',
          descrip: 'Task for work',
          status: 1,
        },
        {
          id: 2,
          name: 'Task 2',
          descrip: 'Task for work',
          status: 2,
        },
        {
          id: 3,
          name: 'Task 3',
          descrip: 'Task for work',
          status: 2,
        },
        {
          id: 4,
          name: 'Task 4',
          descrip: 'Task for work',
          status: 3,
        },
      ],
    }
  },
  methods: {    
    startDrag(el, item) {  
      el.dataTransfer.dropEffect = "move"    
      el.dataTransfer.effectAllowed = "move"       
      el.dataTransfer.setData('itemID', item.id)    
    },    
    onDrop(el, status) {     
      const itemID = el.dataTransfer.getData('itemID')      
      const item = this.listTask.find((item) => item.id == itemID)      
      item.status = status    
    },  
  },
  computed: {     
    listBacklog() {      
      return this.listTask.filter((item) => item.status === 1)    
    },
    listProgress() {      
      return this.listTask.filter((item) => item.status === 2)    
    },  
    listDone() {      
      return this.listTask.filter((item) => item.status === 3)    
    }, 
  },
}
</script>

<style scoped lang="scss">
.board {
  width: 100%;
  height: 100vw;
  display: flex;
  flex-direction: row;
}

.board-column {
  width: 200px;
  height: 100%;
  padding: 10px;
  min-height: 100px;
  box-sizing: border-box;
  border-right: 1px solid #262626;
  &__header {
    padding: 0 0 20px;
    box-sizing: border-box;
  }
  &__list {
    width: 150px;
    height: 150px;
    background: #ccc;
    margin: 0 auto 10px;
    cursor: pointer;
  }
}
</style>
